---
title: MutationObserverInit.characterDataOldValue
slug: Web/API/MutationObserverInit/characterDataOldValue
tags:
  - API
  - Changes
  - Monitoring
  - Mutation Observer
  - Mutation Observer API
  - MutationObserverInit
  - Nodes
  - Reference
  - Textr
  - characterDataOldValue
  - mutation
  - value
---
<div>{{APIRef("DOM WHATWG")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("MutationObserverInit")}}</strong> dictionary's optional <strong><code>characterDataOldValue</code></strong> property is used to specify whether or not the {{domxref("MutationRecord.oldValue")}} property for DOM mutations should be set to the previous value of text nodes which changed.</span></p>

<p>If you set the {{domxref("MutationObserverInit.characterData")}} property to <code>true</code> but don't set <code>characterDataOldValue</code> to <code>true</code> as well, the <code>MutationRecord</code> will not include information describing the prior state of the text node's contents.</p>

<p>Character data changes are detectable on any text node, including nodes based on the {{domxref("Text")}}, {{domxref("ProcessingInstruction")}}, and {{domxref("Comment")}} interfaces.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>options</em> = {
  <em>characterDataOldValue</em>: true | false
}
</pre>

<h3 id="Value">Value</h3>

<p>A Boolean value indicating whether or not to set the <code>MutationRecord</code>'s <code>oldValue</code> property to be a string containing the value of the character node's contents prior to the change represented by the mutation record.</p>

<p>By default, only changes to the text of the node specified as the <code>target</code> parameter when you called {{domxref("MutationObserver.observe", "observe()")}} are monitored. To watch for changes to the text contents of all descendants of <code>target</code>, set the {{domxref("MutationObserverInit.subtree", "subtree")}} option to <code>true</code>.</p>

<p>If you set <code>characterDataOldValue</code> to <code>true</code>, <code>characterData</code> is automatically assumed to be <code>true</code>, even if you don't expressly set it as such.</p>

<h2 id="Example">Example</h2>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-mutationobserverinit-characterdataoldvalue', 'MutationObserverInit.characterDataOldValue')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MutationObserverInit.characterDataOldValue")}}</p>
</div>

